#include <iostream>
#include <math.h>
#include "mm.h"

using namespace std;

// referencna matricna transformacija s float podatki
void float_mm (dat_t x, dat_t y, dat_t *fx, dat_t *fy, float fm[4])
{
	*fx = fm[0]*x + fm[1]*y;
	*fy = fm[2]*x + fm[3]*y;
}

int main()
{
	dat_t x, y, fx, fy;
	m_t m[4];

	float fm[4];
	float fi=45.0;

	// racunaj in izpisi rotacijsko matriko fm, tip: float
	fm[0] = cos(M_PI*fi/180);
	fm[1] = -sin(M_PI*fi/180);
	fm[2] = -fm[1];
	fm[3] = fm[0];

	cout << "fm: ((" << fm[0] << ", " << fm[1] << "),";
	cout << "(" << fm[2] << ", " << fm[3] << "))" << endl;

	// doloci in izpisi matriko m, tip: m_t
	for (int i=0; i<4; i++) m[i] = fm[i];

	cout << "m: ((" << m[0] << ", " << m[1] << "),";
	cout << "(" << m[2] << ", " << m[3] << "))" << endl;

	// izracunaj in izpisi nekaj preslikanih tock
	for (y=20; y<23; y++)
	 for (x=10; x<15; x++) {
	  cout << "(x,y) = " << x << "," << y << " ";
	  mm(x, y, &fx, &fy, m);
	  cout << "(fx,fy) = " << fx << "," << fy << " float: (";
	  float_mm(x, y, &fx, &fy, fm);
	  cout << fx << "," << fy << ")" << endl;
	}


 return 0;
}
